﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Controls.Charts;
using System.Collections.ObjectModel;
using System.Windows.Threading;

namespace SilverlightApplicationInfragisticsCharts
{
    public partial class DataVisualizationChart : UserControl
    {
        ObservableCollection<TestData> Data;
        //List<TestData> Data;
        public DataVisualizationChart()
        {
            InitializeComponent();            
            this.Loaded += new RoutedEventHandler(DataVisualizationChart_Loaded);
            _playTimer.Tick += new EventHandler(_playTimer_Tick);
            
        }

        
        void DataVisualizationChart_Loaded(object sender, RoutedEventArgs e)
        {
            
        }

        private DispatcherTimer _playTimer = new DispatcherTimer { Interval = TimeSpan.FromSeconds(2) };

        void _playTimer_Tick(object sender, EventArgs e)
        {
            LoadChartData();
        }

        public void LoadChartData()
        {

            // Changes the Data in assigned collection
            if (this.Data != null)
            {
                ObservableCollection<TestData> currentData = TestData.GenerateData(this.Data.Count);
                TestData.SynchronizeData(this.Data, currentData);

                //List<TestData> currentData = TestData.GenerateDataList(10);
                //TestData.SynchronizeDataList(this.Data, currentData);
            }
            else
            {
                this.Data = TestData.GenerateData(10);
                xamDataChart1.Series[0].ItemsSource = this.Data;
            }

            //// Changes assigned collection completely
            //this.Data = TestData.GenerateData(10);
            //xamDataChart1.Series[0].ItemsSource = this.Data;
        }


        private void btnLoad_Click(object sender, RoutedEventArgs e)
        {
           LoadChartData();            
        }
                
        private void btnPlay_Click(object sender, RoutedEventArgs e)
        {
            if (_playTimer.IsEnabled)
            {
                _playTimer.Stop();
                btnPlay.Content = "Play";
            }
            else
            {
                _playTimer.Start();
                btnPlay.Content = "Stop";
            }
        }
    }
}
