﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.Generic;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace SilverlightApplicationInfragisticsCharts
{
    public class TestData : INotifyPropertyChanged
    {
        double value;
        double year;
        public double Value
        {
            get
            {
                return this.value;
            }
            set
            {
                this.value = value;
                OnPropertyChanged("Value");
            }
        }

        protected void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        public double Year
        {
            get
            {
                return this.year;
            }
            set
            {
                this.year = value;
                OnPropertyChanged("Year");
            }
        }
        public TestData(double v, double y)
        {
            this.Value = v;
            this.Year = y;
        }

        //public static void GenerateDataLists(out List<double> values, out List<double> years, int count)
        //{
        //    values = new List<double>();
        //    years = new List<double>();
        //    Random rnd = new Random();
        //    for (int i = 0; i < count; i++) // You can test it with i < 10 and i < 100 and i < 200 and soem other values to check the change in behaviour
        //    {

        //        values.Add(rnd.NextDouble() * 100);
        //        years.Add(DateTime.Now.Year - count + i);
        //    }
        //}


        public static ObservableCollection<TestData> GenerateData(int count)
        {
            ObservableCollection<TestData> lst = new ObservableCollection<TestData>();
            Random rnd = new Random();
            for (int i = 0; i < count; i++) // You can test it with i < 10 and i < 100 and i < 200 and soem other values to check the change in behaviour
            {
                lst.Add(new TestData(rnd.NextDouble() * 100, DateTime.Now.Year - count + i));
            }
            return lst;
        }

        public static void SynchronizeData(ObservableCollection<TestData> d1, ObservableCollection<TestData> d2)
        {
            for (int i = 0; i < d1.Count; i++) // You can test it with i < 10 and i < 100 and i < 200 and soem other values to check the change in behaviour
            {
                d1[i].Value = d2[i].Value;
                d1[i].Year = d2[i].Year;
            }
        }


        public static List<TestData> GenerateDataList(int count)
        {
            List<TestData> lst = new List<TestData>();        
            Random rnd = new Random();
            for (int i = 0; i < count; i++) // You can test it with i < 10 and i < 100 and i < 200 and soem other values to check the change in behaviour
            {
                lst.Add(new TestData(rnd.NextDouble() * 100, DateTime.Now.Year - count + i));
            }
            return lst;
        }

        public static void SynchronizeDataList(List<TestData> d1, List<TestData> d2)
        {            
            for (int i = 0; i < d1.Count; i++) // You can test it with i < 10 and i < 100 and i < 200 and soem other values to check the change in behaviour
            {
                d1[i].Value = d2[i].Value;
                d1[i].Year = d2[i].Year;
            }            
        }


        
        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion
    }
}